//
//  LED.c
//
// Routinen zur Ansteuerung der LED Anzeige
//

#include "MyUtils.h"
#include "LED.h"

// Initialisisert das LED Display
void LED_Init( void )
{
    DDRD = 0xFF;
    // SPI aktivieren
    SPI_Enable();

    // Die ersten vier Ziffern als BCD interpretieren
    LED_CMD(LED_DECODE_MODE,0x0F);

    // Intensitt auf Maximum stellen
    LED_CMD(LED_INTENSITY,0x0F);

    // 5 Ziffern anzeigen
    LED_CMD(LED_SCAN_LIMIT,0x04);

	 // Doppelpunkte einstellen
//    LED_CMD(5,0x03);

    // Display aktivieren
    LED_CMD(LED_SHUTDOWN,0x01);

    // SPI deaktivieren
    SPI_Disable();
};

// Zeigt die bergeben Zeit an
void LED_ShowTime(unsigned char Stunden, unsigned char Minuten)
{
   // SPI aktivieren
   SPI_Enable();

	// Zahlen anzeigen
	LED_CMD(4,Stunden / 10);
	LED_CMD(3,Stunden % 10);

	LED_CMD(2,Minuten / 10);
	LED_CMD(1,Minuten % 10);

   // Doppelpunkte einstellen
   LED_CMD(5, 0xFF);

   // SPI deaktivieren
   SPI_Disable();
};



