//
//  LED.h
//
// Routinen zur Ansteuerung der LED Anzeige
//

#ifndef LED_H
#define LED_H

#include <inttypes.h>
#include <avr/io.h>
#include "MyUtils.h"

#define LED_DECODE_MODE 0x09
#define LED_INTENSITY 0x0A
#define LED_SCAN_LIMIT 0x0B
#define LED_SHUTDOWN 0x0C
#define LED_DISPLAY_TEXT 0x0F
#define LED_NO_OP 0x00

#define LOAD_PORT PD6
void LED_Init( void );
void LED_ShowTime(unsigned char Stunden, unsigned char Minuten);

static inline void LED_CMD( unsigned char Command, unsigned char Data)
{
    SPI_Send(Command);
    SPI_Send(Data);

    PORTD |= _BV(LOAD_PORT);
    nop();
    nop();
    PORTD &= ~_BV(LOAD_PORT);
};

#endif

