// LCD.h
//
// Routinen zur Ansteuerung des LCD Displays
//

#ifndef LCD_H
#define LCD_H

#include <inttypes.h>
#include <avr/io.h>
#include "MyUtils.h"

#define RS_PORT PB6
#define E_PORT PB4
#define RW_PORT PB5
#define D7_PORT PB3
#define D6_PORT PB2
#define D5_PORT PB1
#define D4_PORT PB0

#define LCD_INIT 0x28
#define LCD_ON  0x0C
#define LCD_START 0x80
#define LCD_2NDLINE 0xC0
#define LCD_CLEAR 0x01

void LCD_SendByte(register unsigned char byte, register bool Data);
bool LCD_Busy( void );
void LCD_Init( void );
void LCD_ShowText(char Text[32]);
void LCD_BacklightOFF( void );
void LCD_BacklightON(unsigned char Intensity);

#endif


