//
//  SPI.c
//
// Routinen zur Ansteuerung der SPI Schnittstelle
//

#include "MyUtils.h"

void SPI_Enable(void)
{
    DDRB = 0xFF;
    /* Enable SPI, Master, set clock rate fck/16 */
    SPCR = (1<<SPE)|(1<<MSTR);
}
void SPI_Disable(void)
{
    DDRB = 0xFF;
    /* Enable SPI, Master, set clock rate fck/16 */
    SPCR = 0;
    DDRD = 0xFF;
}
void SPI_Send(char cData)
{
    /* Start transmission */
    SPDR = cData;
    /* Wait for transmission complete */
    while(!(SPSR & (1<<SPIF)));
}


