/* Copyright (C) 1991, 1993, 1997, 1998, 2002 Free Software Foundation, Inc.
   This file is part of the GNU C Library.

   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */

// Dieser Code stammt aus der glibc und wurde an meine Bedrfnisse angepasst
// Ich hab ein paar Teile, die in diesem Fall unntig sind entfernt, um die
// Codegre zu verringern und die Funktion an meine Datenstrukturen anzupassen

#include "MyUtils.h"

#define	SECS_PER_HOUR	(unsigned long) (60 * 60)
#define	SECS_PER_DAY	(unsigned long) (SECS_PER_HOUR * 24)

# define __isleap(year)	\
  ((year) % 4 == 0 && ((year) % 100 != 0 || (year) % 400 == 0))

const unsigned short int __mon_yday[2][13] =
  {
    /* Normal years.  */
    { 0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334, 365 },
    /* Leap years.  */
    { 0, 31, 60, 91, 121, 152, 182, 213, 244, 274, 305, 335, 366 }
  };

// Ursprnglicher Name war "__offtime"
// Wandelt eine Zeit in Sekunden seit dem 1.1.2000 in die einzelnen Zeile der
// Zeitangabe um (Stunden, Minuten, Sekunden, Tag, Monat, Jahr und Wochentag)
int ZeitZerlegen(const unsigned long t, struct Time *tp)
{
  long int days, rem;
  unsigned short y;
  const unsigned short int *ip;

  days = t / SECS_PER_DAY;
  rem = t % SECS_PER_DAY;

  tp->Stunden = rem / SECS_PER_HOUR;
  rem %= SECS_PER_HOUR;
  tp->Minuten = rem / 60;
  tp->Sekunden = rem % 60;

  /* January 1, 2000 was a Saturday.  */
  tp->Wochentag = (5 + days) % 7;

  y = 2000;

#define DIV(a, b) ((a) / (b) - ((a) % (b) < 0))
#define LEAPS_THRU_END_OF(y) (DIV (y, 4) - DIV (y, 100) + DIV (y, 400))

  while (days < 0 || days >= (__isleap (y) ? 366 : 365))
    {
      /* Guess a corrected year, assuming 365 days per year.  */
      long int yg = y + days / 365 - (days % 365 < 0);

      /* Adjust DAYS and Y to match the guessed year.  */
      days -= ((yg - y) * 365
	       + LEAPS_THRU_END_OF (yg - 1)
	       - LEAPS_THRU_END_OF (y - 1));
      y = yg;
    }
  tp->Jahr = y - 2000;

  // Fehlerbehandlung entfernt (Sollte man eigentlich nicht tun,
  // aber wie sollte ich einen berlauf in einer Uhr denn behandeln ???)

  ip = __mon_yday[__isleap(y)];
  for (y = 11; days < (long int) ip[y]; --y)
    continue;
  days -= ip[y];
  tp->Monat = y + 1;
  tp->Tag = days + 1;
  return 1;
}

// Setzt eine Zeitangabe aus den einzelnen Komponenten zusammen
unsigned long ZeitZusammensetzen(struct Time *Time)
{
	// Erstmal Tageszeit eintragen
	unsigned short Zeit1 = Time->Sekunden + Time->Minuten * 60;
	unsigned long Result = Zeit1 + Time->Stunden * 3600;
	
	// Tage draufrechnen
	Result += (Time->Tag -1) * SECS_PER_DAY;
	
	// Monate des Jahres dazurechnen
	unsigned short Jahr = Time->Jahr + 2000;
	Result += __mon_yday[__isleap(Jahr)][Time->Monat-1] * SECS_PER_DAY;		
	Jahr--;

   // Jahre dazurechnen
	Result += 365 * SECS_PER_DAY * Time->Jahr;
	
	// Schaltjahre dazurechnen
	while (Jahr >= 2000)
	{
		if (__isleap(Jahr))
			Result += SECS_PER_DAY;	
		Jahr--;
	};	
			
	return Result;
};



